﻿using System;
using System.Windows.Forms;

using System.Drawing;   // necessaria per usare Bitmap e Rectangle

namespace Prova
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        // Punto iniziale del trascinamento con il mouse ...
        int PuntoInizialeX = 0;
        int PuntoInizialeY = 0;

        // Oggetto RECTANGLE per definire l'area da ritagliare ...
        Rectangle miaArea;

        // Oggetti BITMAP per memorizzare l'immagine e il ritaglio ...
        Bitmap miaImmagine;
        Bitmap mioPezzetto;

        // Stato del TRASCINAMENTO (diventa TRUE quando si preme
        // il tasto del mouse e diventa FALSE quando si lascia) ...
        bool StaTrascinando = false;


        private void plsApri_Click(object sender, EventArgs e)
        {
            // Apri la finestra per scegliere un file JPG ...
            OpenFileDialog mioSfoglia = new OpenFileDialog();
            mioSfoglia.Filter = "Immagini JPG|*.jpg";
            mioSfoglia.ShowDialog();

            // Recupera l'immagine dal file scelto, convertila
            // in Bitmap e ponila nell'oggetto miaImmagine ...
            miaImmagine = (Bitmap)Image.FromFile(mioSfoglia.FileName);

            // Visualizza l'immagine SENZA DISTORSIONI ...
            picGrande.Image = miaImmagine;
            picGrande.SizeMode = PictureBoxSizeMode.Normal;

            lblArea.Text = "Trascina il MOUSE sull'immagine per scegliere " + 
                           "l'area da ritagliare ...";
        }


        private void PicGrande_MouseDown(object sender, MouseEventArgs e)
        {
            // Ha iniziato il trascinamento ...

            // Memorizza il punto iniziale del trascinamento ...
            // (l'oggetto "e" passato come parametro nell'evento offre
            //  le proprieta e.X, e.Y per recuperare il punto cliccato)
            PuntoInizialeX = e.X;
            PuntoInizialeY = e.Y;

            // Memorizza il fatto che ha iniziato il trascinamento ...
            StaTrascinando = true;
        }


        private void PicGrande_MouseUp(object sender, MouseEventArgs e)
        {
            // Determina le dimensione del ritaglio ...
            int LarghezzaArea = Math.Abs(e.X - PuntoInizialeX);
            int AltezzaArea = Math.Abs(e.Y - PuntoInizialeY);

            // Crea un oggetto RECTANGLE per definire l'area di ritaglio ...
            miaArea = new Rectangle(PuntoInizialeX, PuntoInizialeY,
                                    LarghezzaArea, AltezzaArea);

            // Usa il metodo .CLONE per creare un altra immagine limitata
            // all'area di ritaglio (ignoriamo il formato ... DontCare!) ...
            mioPezzetto = miaImmagine.Clone(miaArea,
                System.Drawing.Imaging.PixelFormat.DontCare);

            // Visualizza l'immagine ritaglio in un'altra PictureBox ...
            picPezzetto.Image = mioPezzetto;
            picPezzetto.SizeMode = PictureBoxSizeMode.Zoom;

            // Ha terminato il trascinamento ...
            StaTrascinando = false;
        }


        private void PicGrande_MouseMove(object sender, MouseEventArgs e)
        {
            // Se sta trascinando ...
            if ( StaTrascinando )
            {
                // ... allora visualizza le coordinate dell'area di ritaglio ...
                lblArea.Text = PuntoInizialeX + "," + PuntoInizialeY + " - " +
                                e.X + "," + e.Y;
            }
        }
    }
}
